package com.fp.persistence.pgeneral.product;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENESUBPRODINSTALLTYPE*/
@Entity(name="TgeneSubprodInstallType")
@Table(name="TGENESUBPRODINSTALLTYPE")
public class TgeneSubprodInstallType extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneSubprodInstallType
*/
@EmbeddedId
private TgeneSubprodInstallTypeKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

/**Contructor por defecto*/
public TgeneSubprodInstallType(){
}
/**Contructor de TgeneSubprodInstallType
@param pPk Clave Primaria del entity
*/
public TgeneSubprodInstallType(TgeneSubprodInstallTypeKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneSubprodInstallType
*/
public static TgeneSubprodInstallType find(EntityManager pEntityManager,TgeneSubprodInstallTypeKey pKey) throws Exception{
    TgeneSubprodInstallType obj = pEntityManager.find(TgeneSubprodInstallType.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneSubprodInstallType
@return El objeto que referencia a la Clave primaria de TgeneSubprodInstallType
*/
public TgeneSubprodInstallTypeKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneSubprodInstallType
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneSubprodInstallType
*/
public void setPk(TgeneSubprodInstallTypeKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneSubprodInstallType))return false;
    TgeneSubprodInstallType that = (TgeneSubprodInstallType) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneSubprodInstallType
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneSubprodInstallType
*/
public Object createInstance(){
 TgeneSubprodInstallType instance=new TgeneSubprodInstallType();	
 instance.setPk(new TgeneSubprodInstallTypeKey());
 return instance;
}
/**Clona la entidad TgeneSubprodInstallType
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneSubprodInstallType p=(TgeneSubprodInstallType)this.clone();
  p.setPk((TgeneSubprodInstallTypeKey)this.pk.cloneMe());
  return p;
}
}
